﻿using Celeste;
using Celeste.Mod;
using Microsoft.Xna;
using Microsoft.Xna.Framework;
using Monocle;
using MonoMod.Utils;
using System;
using System.Collections;
using System.Reflection;


public class SnakeModule : EverestModule
{
    public static SnakeModule Instance;

    public static SpriteBank guiSpriteBank;

    public override Type SessionType => typeof(SnakeSession);

    public OuiChapterPanel recent;

    public static SnakeSession Session => (SnakeSession)Instance._Session;

    public SnakeModule()
    {
        Instance = this;
    }

    // Check the next section for more information about mod settings, save data and session.
    // Those are optional: if you don't need one of those, you can remove it from the module.

    // If you need to store settings:

    // Set up any hooks, event handlers and your mod in general here.
    // Load runs before Celeste itself has initialized properly.
    public override void Load()
    {
    
    
    }
    public override void Unload()
    {

    }


    public override void LoadContent(bool firstLoad)
    {
        base.LoadContent(firstLoad);
        guiSpriteBank = new SpriteBank(GFX.Game, "Graphics/GuiSprites.xml");
    }



    public void HeartGemDisplay_SetCurrentMode(On.Celeste.HeartGemDisplay.orig_SetCurrentMode orig, HeartGemDisplay self, AreaMode mode, bool has)
    {
        orig.Invoke(self, mode, has);
        if (self.Entity is OuiChapterPanel panel)
        {
            if (SnakeCustomTag2(out OuiChapterPanel p))
            {
                if (p != null)
                {
                    if (p.Area.LevelSet == "python_temple")
                    {
                        if (p.Area.GetSID() == "python_temple/python_temple")
                        {
                            Sprite[] sprites = new Sprite[3];
                            sprites[0] = sprites[1] = sprites[2] = SnakeModule.guiSpriteBank.Create("heartSnake");
                            new DynData<HeartGemDisplay>(self).Set("Sprites", sprites);

                        }
                    }
                }
            }
        }
    }




    private bool SnakeCustomTag2(out OuiChapterPanel p)
    {
        Overworld i = Engine.Scene as Overworld;
        if (i == null)
        {
            p = recent;
            return true;

        }
        if (i != null)
        {
            bool flag2 = i.Current is OuiChapterPanel;
            if (flag2)
            {
                p = (OuiChapterPanel)i.Current;
                recent = p;
                return true;
            }
            bool flag3 = i.Next is OuiChapterPanel;
            if (flag2)
            {
                p = (OuiChapterPanel)i.Next;
                recent = p;
                return true;
            }
        }
        if (Engine.Scene is Overworld)
        {
            Overworld k = Engine.Scene as Overworld;
            if (k.Current is OuiChapterPanel)
            {
                p = (OuiChapterPanel)k.Current;
                recent = p;
                return true;
            }
            if (k.Next is OuiChapterPanel)
            {
                p = (OuiChapterPanel)k.Next;
                recent = p;
                return true;
            }
        }
        p = null;
        return false;
    }
}